{-# OPTIONS_GHC -Wall -}
module Structural(Structural(..),Reconstruct(..),reconstruct,structureList,reconstructWithMap,changeCore,extractRecursively) where

data Reconstruct a b c = RNil b
                       | RCons a (Reconstruct a (c->b) c)
reconstruct :: (Reconstruct a b a) -> b
reconstruct (RNil b) = b
reconstruct (RCons a f) = (reconstruct f) a

reconstructMap :: (d->c) -> (Reconstruct a b c) -> (Reconstruct a b d)
reconstructMap _ (RNil b) = RNil b
reconstructMap f (RCons a r) = RCons a (reconstructMap f (changeCore (\x -> x . f) r))

reconstructWithMap :: (a->c) -> (Reconstruct a b c) -> b
reconstructWithMap f = reconstruct . (reconstructMap f)

changeCore :: (b->d) -> (Reconstruct a b c) -> (Reconstruct a d c)
changeCore f (RNil b) = RNil (f b)
changeCore f (RCons a f') -- f :: (b->d) f' :: Reconstruct a (c->b) c
  = RCons a -- second arg :: Reconstruct a (c->d) c
          (changeCore (f .) -- first arg :: (c->b)->(c->d)
                      f' -- second arg :: (Reconstruct a (c->b) c)
          )

class Structural a where
  structure :: a -> Reconstruct a a a -- we require: "reconstruct (structure x) == x", or in case there is no (Eq a) instance: "reconstruct (structure x) = x"

structureList :: Structural c => c -> [c]
structureList a = getStructuralbits (structure a)

getStructuralbits :: (Reconstruct a b c) -> [a]
getStructuralbits (RCons a as) = a:getStructuralbits as
getStructuralbits (RNil _) = []

extractRecursively :: Structural a => a -> [a]
extractRecursively x = x : concat (map extractRecursively (structureList x))