{-# OPTIONS_GHC -Wall -XFlexibleInstances #-}
{-
- Main file to generate a liveness SMT from an emod structure
-  
-
- Copyright 2014 Sebastiaan J.C. Joosten
- Licensed under the Apache License, Version 2.0 (the "License");
-  you may not use this file except in compliance with the License.
-  You may obtain a copy of the License at
-
-      http://www.apache.org/licenses/LICENSE-2.0
-
-  Unless required by applicable law or agreed to in writing, software
-  distributed under the License is distributed on an "AS IS" BASIS,
-  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-  See the License for the specific language governing permissions and
-  limitations under the License.
-}
module Main (main) where
import EParser (parse,tbrfun,pGetEMOD,pGetLisp,TermBuilder (..))
import ToSMT   (showSMT)

main :: IO ()
main
 = do s <- getContents
      case (parse pGetLisp "(stdin)" s) of
        (Left e) -> putStrLn (show e)
        (Right [g]) -> case (tbrfun (pGetEMOD g) 0) of
                      (TBError e) -> putStrLn (show e)
                      (TB v _) -> do {showSMT v}
        (Right []) -> putStrLn "Please supply input at (stdin)"
        _ -> putStrLn "More than one input not supported"
