module mod (clk, rst);
`include "global.vh"

input clk; input rst;
wire w$src0$0$fork1$0$irdy;
wire w$src0$0$fork1$0$trdy;
wire [`DATA_WIDTH-1:0] w$src0$0$fork1$0$data;
wire w$fork1$0$q3$0$irdy;
wire w$fork1$0$q3$0$trdy;
wire [`DATA_WIDTH-1:0] w$fork1$0$q3$0$data;
wire w$fork1$1$q2$0$irdy;
wire w$fork1$1$q2$0$trdy;
wire [`DATA_WIDTH-1:0] w$fork1$1$q2$0$data;
wire w$q2$0$join4$1$irdy;
wire w$q2$0$join4$1$trdy;
wire [`DATA_WIDTH-1:0] w$q2$0$join4$1$data;
wire w$q3$0$join4$0$irdy;
wire w$q3$0$join4$0$trdy;
wire [`DATA_WIDTH-1:0] w$q3$0$join4$0$data;
wire w$join4$0$sink5$0$irdy;
wire w$join4$0$sink5$0$trdy;
wire [`DATA_WIDTH-1:0] w$join4$0$sink5$0$data;
xmas_source src0 (clk, rst,
  // output 0 : w$src0$0$fork1$0
  w$src0$0$fork1$0$irdy,  w$src0$0$fork1$0$trdy,  w$src0$0$fork1$0$data);
xmas_fork fork1 (clk, rst,
  // input 0 : w$src0$0$fork1$0
  w$src0$0$fork1$0$irdy,  w$src0$0$fork1$0$trdy,  w$src0$0$fork1$0$data,
  // output 0 : w$fork1$0$q3$0
  w$fork1$0$q3$0$irdy,  w$fork1$0$q3$0$trdy,  w$fork1$0$q3$0$data,
  // output 1 : w$fork1$1$q2$0
  w$fork1$1$q2$0$irdy,  w$fork1$1$q2$0$trdy,  w$fork1$1$q2$0$data);
xmas_queue_2 buffer (clk, rst,
  // input 0 : w$fork1$0$q3$0
  w$fork1$0$q3$0$irdy,  w$fork1$0$q3$0$trdy,  w$fork1$0$q3$0$data,
  // output 0 : w$q3$0$join4$0
  w$q3$0$join4$0$irdy,  w$q3$0$join4$0$trdy,  w$q3$0$join4$0$data);
counter couter (clk, rst,
  // input 0 : w$fork1$1$q2$0
  w$fork1$1$q2$0$irdy,  w$fork1$1$q2$0$trdy,  w$fork1$1$q2$0$data,
  // output 0 : w$q2$0$join4$1
  w$q2$0$join4$1$irdy,  w$q2$0$join4$1$trdy,  w$q2$0$join4$1$data);
xmas_join join4 (clk, rst,
  // input 0 : w$q3$0$join4$0
  w$q3$0$join4$0$irdy,  w$q3$0$join4$0$trdy,  w$q3$0$join4$0$data,
  // input 1 : w$q2$0$join4$1
  w$q2$0$join4$1$irdy,  w$q2$0$join4$1$trdy,  w$q2$0$join4$1$data,
  // output 0 : w$join4$0$sink5$0
  w$join4$0$sink5$0$irdy,  w$join4$0$sink5$0$trdy,  w$join4$0$sink5$0$data);
xmas_sink sink5 (clk, rst,
  // input 0 : w$join4$0$sink5$0
  w$join4$0$sink5$0$irdy,  w$join4$0$sink5$0$trdy,  w$join4$0$sink5$0$data);
endmodule

module counter (clk,
    rst,
    i$irdy,
    i$trdy,
    i$data,
    o$irdy,
    o$trdy,
    o$data);

input clk, rst;
    
input i$irdy;
output i$trdy;
input [`DATA_WIDTH-1:0] i$data;

output o$irdy;
input o$trdy;
output [`DATA_WIDTH-1:0] o$data;

reg bit0;
reg bit1;
assign i$trdy = !bit0; // QUEUE_DEPTH - 1
assign o$irdy = bit1;
assign o$data = i$data;

wire writing = i$irdy && i$trdy;
wire reading = o$irdy && o$trdy;

always @(posedge clk) bit0 <= rst?0:(writing ? 1 : (bit0 ? bit1 : 0));
always @(posedge clk) bit1 <= rst?0:(reading ? 0 : (bit1 ? 1 : bit0));

endmodule
